use std::fs;
use std::fs::OpenOptions;
use std::io::prelude::*;

/// Likh v0.01
/// library to write and read from text and CSV files.

/*

MIT License
-----------

Copyright (c) 2019 Jagadeesh Kotra (jkotra.github.io)
Permission is hereby granted, free of charge, to any person
obtaining a copy of this software and associated documentation
files (the "Software"), to deal in the Software without
restriction, including without limitation the rights to use,
copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the
Software is furnished to do so, subject to the following
conditions:

The above copyright notice and this permission notice shall be
included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
OTHER DEALINGS IN THE SOFTWARE.
		

*/
pub fn read_from_file(filename: &str) -> String{
    let contents = fs::read_to_string(filename).expect("Something went wrong reading the file");
    return contents;
}

pub fn write_to_file(filename: &str, content: &str){

    fs::write(filename, content).expect("Cannot open file!");
    }


pub fn read_from_csv<'a> (content: &'a str) -> Vec<Vec<&'a str>> {

    let mut data = vec![];

    for line in content.split("\n"){
        let mut line_vec = vec![];
        for row in line.split(","){
            line_vec.push(row);
        }
        data.push(line_vec);
    }
    return data;
}

pub fn write_to_csv<'a> (content: Vec<Vec<&str>>,file_path: &str) {
    let mut file = OpenOptions::new().append(true).create(true).open(file_path).unwrap();
    for row in content{
        let row_content = row.join(",");
        write!(&mut file, "{}\n",row_content).expect("Unable t owrite to file!")
    }
}

#[cfg(test)]
mod tests {
    #[test]
    fn it_works() {
        assert_eq!(2 + 2, 4);
    }
    
    #[test]
    fn read_test() {
        let output = super::read_from_file("tests/data.txt");
        assert_eq!(output, "Hello, World!\n");
    }

    #[test]
    fn write_test() {
        super::write_to_file("tests/writetome.txt", "Test123#123#");
        let read_output = super::read_from_file("tests/writetome.txt");
        assert_eq!(read_output, "Test123#123#");
    }
 }